Package org.apache.sis.metadata.iso.lineage

## Class DefaultNominalResolution

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultNominalResolution

- All Implemented Interfaces:
    `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `NominalResolution`

      public class DefaultNominalResolution
      extends ISOMetadata
      implements NominalResolution

  Distance between consistent parts of (centre, left side, right side) adjacent pixels. The following properties are mandatory in a well-formed metadata according ISO 19115:
  `LE_NominalResolution` `├─scanningResolution……` Distance between consistent parts of (centre, left side, right side) adjacent pixels in the scan plane. `└─groundResolution…………` Distance between consistent parts of (centre, left side, right side) adjacent pixels in the object space.

  Limitations:

  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    Serialized Form

  Defined in the `sis-metadata` module

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ModifiableMetadata

      `ModifiableMetadata​.State`

  - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DefaultNominalResolution()` | Constructs an initially empty nominal resolution.
    `DefaultNominalResolution​(NominalResolution object)` | Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultNominalResolution` | `castOrCopy​(NominalResolution object)` | Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Double` | `getGroundResolution()` | Returns the distance between consistent parts of (centre, left side, right side) adjacent pixels in the object space.
    `Double` | `getScanningResolution()` | Returns the distance between consistent parts of (centre, left side, right side) adjacent pixels in the scan plane.
    `void` | `setGroundResolution​(Double newValue)` | Sets the distance between consistent parts of (centre, left side, right side) adjacent pixels in the object space.
    `void` | `setScanningResolution​(Double newValue)` | Sets the distance between consistent parts of (centre, left side, right side) adjacent pixels in the scan plane.

    - ### Methods inherited from class ISOMetadata

      `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, freeze, isModifiable, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, unmodifiable, writeCollection, writeList, writeMap, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultNominalResolution

          public DefaultNominalResolution()

      Constructs an initially empty nominal resolution.

    - #### DefaultNominalResolution

          public DefaultNominalResolution​(NominalResolution object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Note on properties validation: This constructor does not verify the property values of the given metadata (e.g. whether it contains unexpected negative values). This is because invalid metadata exist in practice, and verifying their validity in this copy constructor is often too late. Note that this is not the only hole, as invalid metadata instances can also be obtained by unmarshalling an invalid XML document.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(NominalResolution)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultNominalResolution castOrCopy​(NominalResolution object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is already an instance of `DefaultNominalResolution`, then it is returned unchanged.
      - Otherwise a new `DefaultNominalResolution` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getScanningResolution

          @ValueRange(minimum=0.0,
                      isMinIncluded=false)
          public Double getScanningResolution()

      Returns the distance between consistent parts of (centre, left side, right side) adjacent pixels in the scan plane.
      Specified by:
        `getScanningResolution` in interface `NominalResolution`
      Returns:
        distance between consistent parts of adjacent pixels in the scan plane, or `null`.

    - #### setScanningResolution

          public void setScanningResolution​(Double newValue)

      Sets the distance between consistent parts of (centre, left side, right side) adjacent pixels in the scan plane.
      Parameters:
        `newValue` - the new scanning resolution value.
      Throws:
        `IllegalArgumentException` - if the given value is NaN, zero or negative.

    - #### getGroundResolution

          @ValueRange(minimum=0.0,
                      isMinIncluded=false)
          public Double getGroundResolution()

      Returns the distance between consistent parts of (centre, left side, right side) adjacent pixels in the object space.
      Specified by:
        `getGroundResolution` in interface `NominalResolution`
      Returns:
        distance between consistent parts of adjacent pixels in the object space, or `null`.

    - #### setGroundResolution

          public void setGroundResolution​(Double newValue)

      Sets the distance between consistent parts of (centre, left side, right side) adjacent pixels in the object space.
      Parameters:
        `newValue` - the new ground resolution value.
      Throws:
        `IllegalArgumentException` - if the given value is NaN, zero or negative.